#ifndef GGAFLIB_LINEAROCTREEFORACTOR_H_
#define GGAFLIB_LINEAROCTREEFORACTOR_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/core/util/GgafLinearOctree.h"

namespace GgafLib {

#define MAX_COLLISIONSTACK_ACTOR_NUM (2000)
/**
 * GgafActorvfƂ蔻@\ǉ`ؔzNX .
 * AO[v  BO[v2O[vԂ̓蔻s
 * @version 1.00
 * @since 2009/11/23
 * @author Masatoshi Tsuge
 */
class LinearOctreeForActor : public GgafCore::GgafLinearOctree {

    uint32_t _num_space_minus_one;

public:
    /**
     * 蔻AN^[ێX^bN .
     * ̎lĂȂ댯ȃX^bN
     */
    class CollisionStack {
    public:
        /** [r]̋ԂɃX^bNAN^[̔z */
        GgafCore::GgafActor* _apActor[MAX_COLLISIONSTACK_ACTOR_NUM]; //PԂ 3000 LW܂Ȃ낤ƂՂŐ͂Ȍς
        /** [r]J[\|C^(PUSHovfwĂ)  */
        uint32_t _p;
    public:
        /**
         * RXgN^
         * @return
         */
        CollisionStack() {
            _p = 0;
        }
        /**
         * X^bNɐς .
         * @param prm_pActor ςރAN^[
         */
        inline void push(GgafCore::GgafActor* prm_pActor) {
            if (_p == MAX_COLLISIONSTACK_ACTOR_NUM) {
                _TRACE_("x LinearOctreeForActor::push("<<prm_pActor<<") X^bNg؂܂B܂Bӏɓ蔻肪߂łB");
                return;
            }
            _apActor[_p] = prm_pActor;
            _p++;
        }

        /**
         * X^bNo .
         * @return oꂽAN^[
         */
        inline GgafCore::GgafActor* pop() {
            if (_p == 0) {
                return nullptr;
            } else {
                _p--;
                return (_apActor[_p]);
            }
        }

        /**
         * ̃X^bNSĎoAo莩g̃X^bNɐς .
         * @param prm_pCollisionStack
         */
        inline void pop_push(CollisionStack* prm_pCollisionStack) {
            if (_p == MAX_COLLISIONSTACK_ACTOR_NUM) {
                _TRACE_("x LinearOctreeForActor::pop_push("<<prm_pCollisionStack<<") X^bNg؂Ă܂B܂Bӏɓ蔻肪߂łB");
                prm_pCollisionStack->_p = 0;
                return;
            }
            while (_apActor[_p] = prm_pCollisionStack->pop()) { //  I know "=" , not "=="
                _p++;
                if (_p == MAX_COLLISIONSTACK_ACTOR_NUM) {
                    _TRACE_("x LinearOctreeForActor::pop_push("<<prm_pCollisionStack<<") X^bNg؂܂B܂Bӏɓ蔻肪߂łB");
                    prm_pCollisionStack->_p = 0;
                    break;
                }
            }
        }
        /**
         * ς񂾃X^bNȂɂB .
         */
        inline void clear() {
            _p = 0;
        }
        ~CollisionStack() {
            clear();
        }
        void dump() {
            _TRACE5_N_("CollisionStack.dump=");
            for (uint32_t i = 0; i < _p; i++) {
                _TRACE5_N_((_apActor[i]->getName())<<"->");
            }
            _TRACE5_N_("END");
        }
    };

    /** [r]SԂ̓蔻莞A݂̋ԂɏAN^[AO[ṽX^bN */
    CollisionStack _stackCurrentOctantActor_GroupA;
    /** [r]SԂ̓蔻莞A݂̋ԂɏAN^[BO[ṽX^bN */
    CollisionStack _stackCurrentOctantActor_GroupB;
    /** [r]Ԃ̓蔻莞AeԂɏSAN^[AO[ṽX^bN */
    CollisionStack _stackParentOctantActor_GroupA;
    /** [r]Ԃ̓蔻莞AeԂɏSAN^[BO[ṽX^bN */
    CollisionStack _stackParentOctantActor_GroupB;

    /** [r]񓖂蔻sAN^[A */
    actorkind _kind_groupA;
    /** [r]񓖂蔻sAN^[B */
    actorkind _kind_groupB;

public:
    /**
     * RXgN^
     * @param prm_level 쐬锪؋ԃx
     */
    explicit LinearOctreeForActor(int prm_level);

    /**
     * ؏́uAN^[AO[v  AN^[BO[vvs  .
     * Av͖{\bhĂԂł悢B<BR>
     *  executeAllHitChk  processJudgement() ŌĂԕKvB<BR>
     * @param prm_groupA AN^[AO[v
     * @param prm_groupB AN^[BO[v
     */
    void executeAllHitChk(actorkind prm_groupA, actorkind prm_groupB);

    /**
     * ̋Ԃ̓蔻s  .
     * executeAllHitChk gpB
     * @param prm_index `ؔz̔zvfԍ
     */
    void executeHitChk(uint32_t prm_index);

    /**
     * AN^[AO[ṽX^bNƁAAN^[BO[ṽX^bN̑̓蔻s  .
     * executeHitChk gpB
     * @param prm_pStackA AN^[AO[ṽX^bN
     * @param prm_pStackB AN^[BO[ṽX^bN
     */
    void executeHitChk_RoundRobin(CollisionStack* prm_pStackA, CollisionStack* prm_pStackB);

    virtual ~LinearOctreeForActor();
};


}
#endif /*GGAFLIB_LINEAROCTREEFORACTOR_H_*/

