#include "jp/ggaf/lib/actor/laserchip/LaserChip.h"

#include "jp/ggaf/dxcore/exception/GgafDxCriticalException.h"
#include "jp/ggaf/dxcore/model/GgafDxMeshSetModel.h"
#include "jp/ggaf/dxcore/effect/GgafDxMeshSetEffect.h"
#include "jp/ggaf/dxcore/scene/GgafDxSpacetime.h"
#include "jp/ggaf/lib/util/CollisionChecker3D.h"
#include "jp/ggaf/lib/actor/laserchip/LaserChipDepository.h"
#include "jp/ggaf/lib/actor/ColliAABActor.h"
#include "jp/ggaf/lib/actor/ColliAAPrismActor.h"
#include "jp/ggaf/lib/actor/ColliSphereActor.h"

using namespace GgafCore;
using namespace GgafDxCore;
using namespace GgafLib;

LaserChip::LaserChip(const char* prm_name, const char* prm_model, GgafStatus* prm_pStat) :
      GgafDxMeshSetActor(prm_name,
                         std::string("11/" + std::string(prm_model)).c_str(),
                         "LaserChipEffect",
                         "LaserChipTechnique",
                         prm_pStat,
                         NEW CollisionChecker3D(this) ) {
    _pMeshSetModel->_set_num = 11; //݂̃[U[̍őZbg11B
    _obj_class |= Obj_LaserChip;
    _pColliChecker = (CollisionChecker3D*)_pChecker;
    _class_name = "LaserChip";
    _pChip_front = nullptr;
    _pChip_behind = nullptr;
    _pDepo = nullptr; //LaserChipDepositoryɒǉ鎞ɐݒ肳BʏLaserChipLaserChipDepository̓ZbgB
    _chip_kind = 1;
    _hitarea_edge_length = 0;
    _harf_hitarea_edge_length = 0;
    _can_chikei_hit = false;

    setZEnable(true);        //Zobt@͍lL
    setZWriteEnable(false);  //Zobt@͏ݖ
    setAlpha(0.99);
    _middle_colli_able = false;

    static volatile bool is_init = LaserChip::initStatic(); //ÓIo
}

D3DXHANDLE LaserChip::_ah_kind[11];
D3DXHANDLE LaserChip::_ah_force_alpha[11];
D3DXHANDLE LaserChip::_ah_matWorld_front[11];
bool LaserChip::initStatic() {
    ID3DXEffect* const pID3DXEffect = _pMeshSetEffect->_pID3DXEffect;
    LaserChip::_ah_kind[0]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind001" );
    LaserChip::_ah_kind[1]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind002" );
    LaserChip::_ah_kind[2]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind003" );
    LaserChip::_ah_kind[3]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind004" );
    LaserChip::_ah_kind[4]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind005" );
    LaserChip::_ah_kind[5]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind006" );
    LaserChip::_ah_kind[6]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind007" );
    LaserChip::_ah_kind[7]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind008" );
    LaserChip::_ah_kind[8]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind009" );
    LaserChip::_ah_kind[9]  = pID3DXEffect->GetParameterByName( nullptr, "g_kind010" );
    LaserChip::_ah_kind[10] = pID3DXEffect->GetParameterByName( nullptr, "g_kind011" );
    LaserChip::_ah_force_alpha[0]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha001" );
    LaserChip::_ah_force_alpha[1]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha002" );
    LaserChip::_ah_force_alpha[2]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha003" );
    LaserChip::_ah_force_alpha[3]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha004" );
    LaserChip::_ah_force_alpha[4]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha005" );
    LaserChip::_ah_force_alpha[5]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha006" );
    LaserChip::_ah_force_alpha[6]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha007" );
    LaserChip::_ah_force_alpha[7]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha008" );
    LaserChip::_ah_force_alpha[8]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha009" );
    LaserChip::_ah_force_alpha[9]  = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha010" );
    LaserChip::_ah_force_alpha[10] = pID3DXEffect->GetParameterByName( nullptr, "g_force_alpha011" );
    LaserChip::_ah_matWorld_front[0]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front001" );
    LaserChip::_ah_matWorld_front[1]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front002" );
    LaserChip::_ah_matWorld_front[2]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front003" );
    LaserChip::_ah_matWorld_front[3]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front004" );
    LaserChip::_ah_matWorld_front[4]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front005" );
    LaserChip::_ah_matWorld_front[5]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front006" );
    LaserChip::_ah_matWorld_front[6]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front007" );
    LaserChip::_ah_matWorld_front[7]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front008" );
    LaserChip::_ah_matWorld_front[8]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front009" );
    LaserChip::_ah_matWorld_front[9]  = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front010" );
    LaserChip::_ah_matWorld_front[10] = pID3DXEffect->GetParameterByName( nullptr, "g_matWorld_front011" );
    return true;
}

void LaserChip::executeHitChk_MeAnd(GgafActor* prm_pOtherActor) {
    if (prm_pOtherActor->instanceOf(Obj_WallPartsActor)) { //肪n`ubN
        if (_chip_kind == 3 || _can_chikei_hit) {  //3:Ԑ擪`bv A1/16̒n`蔻L`bv
            GgafDxFigureActor::executeHitChk_MeAnd(prm_pOtherActor);
        } else {
            return;
        }
    } else {
        GgafDxFigureActor::executeHitChk_MeAnd(prm_pOtherActor);
    }
}

void LaserChip::onActive() {
    //o
    _chip_kind = 1;
    if (_pDepo) {
        _pDepo->_num_chip_active++;
    }
    _force_alpha = 1.00; //ŏ͉łnbLfB
    if (_middle_colli_able) {
        getCollisionChecker()->disable(1);
    }
}

void LaserChip::processSettlementBehavior() {
    CollisionChecker3D* pChecker = getCollisionChecker();
    const LaserChip* pChip_front = _pChip_front;


    //[U[`bv ݒB
    //VF[_[̃p[^ƂȂ܂B
    //
    //      -==========<>            [U[
    //
    //      -= === === === <>        ȂӂɕfĂ܂B
    //                               cɋ؂Ẳӏ LaserChip IuWFNgłB
    //    | -=|===|===|===|<> |      }̓[U[IuWFNgŋ؂̐}
    //
    //    <--><--><--><--><-->^
    //    ^   ^   ^   ^   ^   |
    //    |   |   |   |   |   |
    //    |   |   |   |   |    `----- 4:[`bv(\ŁAԐ擪`bv\邽߂ɑ)
    //    |   |   |   |    `----- 3:Ԑ擪`bv(\̐擪)
    //    |   |   |    `----- 2:ԃ`bv
    //    |   |    `----- 2:ԃ`bv
    //    |    `----- 2:ԃ`bv
    //     `----- 1:`bv
    //
    //擪Ɛ[ƂtŋʂĂ܂B
    setHitAble(true);
    if (pChip_front) {
        if (pChip_front->isActive()) {
            if (_pChip_behind) {
                if (_pChip_behind->isActiveInTheTree()) {
                    if (pChip_front->_pChip_front) {
                        _chip_kind = 2; //ԃeNX``bv
                        _pLeader = pChip_front->_pLeader;
                    } else {
                        _chip_kind = 3; //Ԑ擪eNX``bv
                        _pLeader = pChip_front->_pLeader;
                    }
                } else {
                    _chip_kind = 1; //ˌ̖[eNX``bv
                    _pLeader = pChip_front->_pLeader;
                }
            } else {
                _chip_kind = 1; //ʂ̖[eNX`
                _pLeader = pChip_front->_pLeader;
            }
        } else {
            _chip_kind = 4; //[`bvB`悵Ȃ
            _pLeader = this;
            _pChip_front->_pChip_behind = nullptr; //ÔȂ
            _pChip_front = nullptr;                //ؒf
            if (getActiveFrame() > 1 && _pChip_behind == nullptr) {
                sayonara();
            }
            setHitAble(false);
        }
    } else {
        _chip_kind = 4; //[`bvB`悵Ȃ
        _pLeader = this;
        if (getActiveFrame() > 1 && _pChip_behind == nullptr) {
            sayonara();
        }
        setHitAble(false);
    }

    //̏processBehavior()ōsȂBȂȂ΁A_pChip_front Wړς݂̕ۏ؂Ȃ߁B
    if (_middle_colli_able) { //炭T[U[`bv̏ꍇ
        if (_chip_kind != 4) {
            coord dX = pChip_front->_x - _x;
            coord dY = pChip_front->_y - _y;
            coord dZ = pChip_front->_z - _z;
            coord abs_dx = ABS(dX);
            coord abs_dy = ABS(dY);
            coord abs_dz = ABS(dZ);

            if (abs_dx < _hitarea_edge_length &&
                abs_dy < _hitarea_edge_length &&
                abs_dz < _hitarea_edge_length) {
                //O`bvƂꍇɁÄꎞIɖ
                setHitAble(false);
            } else {
                setHitAble(true);
                if (abs_dx >= _hitarea_edge_length_3 ||
                    abs_dy >= _hitarea_edge_length_3 ||
                    abs_dz >= _hitarea_edge_length_3) {
                    //O`bvƗꂷꍇɁAԂɓ蔻̈ꎞIɗL
                    //gƑO`bv̒Ԃɓ蔻o
                    int cX = dX / 2;
                    int cY = dY / 2;
                    int cZ = dZ / 2;
                    pChecker->setColliAAB(
                                  1,
                                  cX - _harf_hitarea_edge_length,
                                  cY - _harf_hitarea_edge_length,
                                  cZ - _harf_hitarea_edge_length,
                                  cX + _harf_hitarea_edge_length,
                                  cY + _harf_hitarea_edge_length,
                                  cZ + _harf_hitarea_edge_length
                                  );
                    pChecker->enable(1);
                } else {
                    pChecker->disable(1);
                }
            }
        } else {
            pChecker->disable(1);
        }
    }


    if (isOutOfSpacetime()) {
        sayonara();
    }

    //ŏ͉łnbLfB
    //1b͋ɊĔ܂dl
    if (getActiveFrame() > 60 && _force_alpha > 0) {
        _force_alpha -= 0.01;
    }
    GgafDxMeshSetActor::processSettlementBehavior(); //ؓo^
    //TODO:ؓo^ȂprocessSettlementBehavior()Ăяô͏ȂB
    //蔻̈XVĂprocessSettlementBehaviorŔؓo^邱ƁB
}

void LaserChip::processPreDraw() {
    if (_chip_kind < 4) {
        //4ȊO\Ώۂɂ
        GgafDxFigureActor::processPreDraw();
    }
}

void LaserChip::processDraw() {
    int draw_set_num = 0; //GgafDxMeshSetActor̓fœeNjbN
                       //AĂJEgB`[x͈xɕ`悷B
    ID3DXEffect* const pID3DXEffect = _pMeshSetEffect->_pID3DXEffect;
    HRESULT hr;
    //{f_
    GgafDxFigureActor* pDrawActor = this;
    LaserChip* pLaserChip = nullptr;
    int model_set_num = _pMeshSetModel->_set_num;

    while (pDrawActor) {
        if (pDrawActor->getModel() == _pMeshSetModel && pDrawActor->_hash_technique == _hash_technique) {
            pLaserChip = (LaserChip*)pDrawActor;
            //ւňӖsȃG[ɂȂA
            //GgafDxSpriteLaserChipActor[MEMO]ǂݒI
            if (pLaserChip->_pChip_front) {
                //g[hϊs
                hr = pID3DXEffect->SetMatrix(_pMeshSetEffect->_ah_matWorld[draw_set_num], &(pLaserChip->_matWorld));
                checkDxException(hr, D3D_OK, "LaserChip::processDraw() SetMatrix(_ah_matWorld) Ɏs܂B");
                //Õ[hϊs
                hr = pID3DXEffect->SetMatrix(LaserChip::_ah_matWorld_front[draw_set_num], &(pLaserChip->_pChip_front->_matWorld));
                checkDxException(hr, D3D_OK, "LaserChip::processDraw() SetMatrix(_ah_matWorld_front) Ɏs܂B1");
                //`bv
                hr = pID3DXEffect->SetInt(LaserChip::_ah_kind[draw_set_num], pLaserChip->_chip_kind);
                checkDxException(hr, D3D_OK, "LaserChip::processDraw() SetInt(LaserChip::_ah_kind) Ɏs܂B2");

                hr = pID3DXEffect->SetFloat(LaserChip::_ah_force_alpha[draw_set_num], pLaserChip->_force_alpha);
                checkDxException(hr, D3D_OK, "LaserChip::processDraw() SetFloat(LaserChip::_ah_force_alpha) Ɏs܂B2");

                draw_set_num++;
                if (draw_set_num >= model_set_num) {
                    break;
                }

            } else {
                //[`bv͕`sv
            }
            pDrawActor = pDrawActor->_pNextActor_in_draw_depth_level;
        } else {
            break;
        }
    }
    GgafDxSpacetime::_pActor_draw_active = pLaserChip; //`Zbg̍ŌAN^[Zbg
    if (draw_set_num > 0) { //`悳Ȃ\邽߂̔肪Kv
        _pMeshSetModel->GgafDxMeshSetModel::draw(this, draw_set_num);
    }
}

void LaserChip::drawHitArea() {
    ColliAABActor::get()->drawHitarea(_pColliChecker); ColliAAPrismActor::get()->drawHitarea(_pColliChecker); ColliSphereActor::get()->drawHitarea(_pColliChecker);
}

void LaserChip::onInactive() {
    //
    if (_pDepo) {
        _pDepo->_num_chip_active--;
        if (_pDepo->_num_chip_active < 0) {
            _pDepo->_num_chip_active = 0;
            //GgafActorDepository::onReset() ɂ onInactive() ̂ŁAɂȂ鎞ƂȂ
        }
    }
    //Ǒqؒf
    if (_pChip_front) {
        _pChip_front->_pChip_behind = nullptr;
    }
    _pChip_front = nullptr;
    if (_pChip_behind) {
        _pChip_behind->_pChip_front = nullptr;
    }
    _pChip_behind = nullptr;
    _pLeader = nullptr;
}

void LaserChip::registerHitAreaCube_AutoGenMidColli(int prm_edge_length) {
    //ʃ[U[`bvŃI[o[CgĂ\
    _middle_colli_able = true;
    _hitarea_edge_length = prm_edge_length;
    _hitarea_edge_length_3 = _hitarea_edge_length*3;
    _harf_hitarea_edge_length = _hitarea_edge_length / 2;
    CollisionChecker3D* pChecker = getCollisionChecker();
    pChecker->makeCollision(2);
    pChecker->setColliAAB_Cube(0, prm_edge_length);
    pChecker->setColliAAB_Cube(1, prm_edge_length);
    pChecker->disable(1);
    setHitAble(true);
}

void LaserChip::setAlpha(float prm_alpha) {
    _alpha = prm_alpha;
    //ݒA[U[`bv́A_paMaterial͎gpȂ
}

void LaserChip::addAlpha(float prm_alpha) {
    _alpha += prm_alpha;
    //ݒA[U[`bv́A_paMaterial͎gpȂ
}

LaserChip::~LaserChip() {
    GGAF_DELETE(_pColliChecker);
}

